#ifndef SHMEMQUEUE_H
#define SHMEMQUEUE_H

#include "nt_ipvishm_message_queue.h"
#include <windows.h>

#define SHMEM_Q_AVAIL_FOR_WRITE		0
#define SHMEM_Q_BEING_WRITTEN		1
#define SHMEM_Q_AVAIL_FOR_READ		2
#define SHMEM_Q_BEING_READ			3
#define SHMEM_Q_READ				4

class ShmemQueue
{
public:
	struct ShmemQueueHeader
	{
		int tag, from, state;
		unsigned int length;
		unsigned long next_offset;
	};

	ShmemQueue();
	~ShmemQueue();

	bool Init(char *name, unsigned long size);
	bool Insert(unsigned char *buffer, unsigned int length, int tag, int from);
	bool RemoveNext(unsigned char *buffer, unsigned int *length, int *tag, int *from);
	bool RemoveNextInsert(MessageQueue *pMsgQueue);

private:
	HANDLE m_hMapping, m_hQMutex, m_hMsgAvailableEvent, m_hQEmptyEvent;
	LPVOID m_pBase, m_pEnd;
	unsigned long m_dwSize, m_dwMaxMsgSize;
};

#endif
